config/routes.rb
Rails.application.routes.draw do
  resources :leaderboards
  devise_for :users
  resources :lessons
  resources :questions
  resources :quizzes
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  # post 'submit_quiz', to: 'take_quiz#submit'
  post 'take_quiz/:quiz_id/submit', to: 'take_quiz#submit', as: :submit_quiz

  resources :quizzes do
    resources :questions
  end

  resources :lessons do
    resources :comments, only: [:create]
  end

  resources :leaderboards, only: [:index]
  
  resources :take_quiz, only: [:index, :show]
  # Defines the root path route ("/")
  # root "posts#index"
  root to: "lessons#index"
end

app/models/question.rb
class Question < ApplicationRecord
  belongs_to :quiz
  serialize :options, Array, coder: YAML
end

app/controllers/questions_controller.rb
class QuestionsController < ApplicationController
  before_action :set_question, only: %i[ show edit update destroy ]

  # GET /questions or /questions.json
  def index
    @questions = Question.all
  end

  # GET /questions/1 or /questions/1.json
  def show
  end

  # GET /questions/new
  def new
    @quiz = Quiz.find(params[:quiz_id])
    @question = @quiz.questions.build
  end

  # GET /questions/1/edit
  def edit
  end

  # POST /questions or /questions.json
  def create
    @question = Question.new(question_params)
    respond_to do |format|
      if @question.save
        format.html { redirect_to question_url(@question), notice: "Question was successfully created." }
        format.json { render :show, status: :created, location: @question }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  def create
    @quiz = Quiz.find(params[:quiz_id])
    @question = @quiz.questions.build(question_params)
    if @question.save
      redirect_to [@quiz, @question], notice: 'Question was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /questions/1 or /questions/1.json
  def update
    respond_to do |format|
      if @question.update(question_params)
        format.html { redirect_to question_url(@question), notice: "Question was successfully updated." }
        format.json { render :show, status: :ok, location: @question }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /questions/1 or /questions/1.json
  def destroy
    @question.destroy!

    respond_to do |format|
      format.html { redirect_to questions_url, notice: "Question was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_question
      @question = Question.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    # def question_params
    #   params.fetch(:question, {})
    # end
    private

    def question_params
      params.require(:question).permit(:title, :content, :correct_answer, options: [])
    end
    
end

app/helpers/questions_helper.rb
module QuestionsHelper
end

app/views/questions/_form.html.erb
<%= form_with(model: [@quiz, question]) do |form| %>
  <% if question.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(question.errors.count, "error") %> prohibited this question from being saved:</h2>
      <ul>
        <% question.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <!-- Multiple Choice Options Fields with Radio Buttons for Correct Answer -->
  <% (1..4).each do |index| %>
    <div class="field">
      <%= form.label "option_#{index}" %>
      <%= form.text_field :options, name: "question[options][]", id: "question_options_#{index}" %>
      <%= form.radio_button :correct_answer, index, id: "question_correct_answer_#{index}" %>
      <%= form.label :correct_answer, index, value: index, for: "question_correct_answer_#{index}" %>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/questions/_question.html.erb
<div id="<%= dom_id question %>">
</div>

app/views/questions/edit.html.erb
<h1>Editing question</h1>

<%= render "form", question: @question %>

<br>

<div>
  <%= link_to "Show this question", @question %> |
  <%= link_to "Back to questions", questions_path %>
  
</div>

app/views/questions/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Questions</h1>

<div id="questions">
  <% @questions.each do |question| %>
    <%= render question %>
    <p>
      Question ID = 
      <%= question.id %>
      <%= question.title %>
      <%= link_to "Question Details", question %>
    </p>
  <% end %>
</div>

<%= link_to "New question", new_question_path %>
<%= link_to 'View Quizzes', quizzes_path %>

app/views/questions/new.html.erb
<h1>New question</h1>

<%= render "form", question: @question %>
<br>

<div>
  <%= link_to "Back to questions", questions_path %>
</div>

app/views/questions/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @question %>

<p>
  <strong>Question:</strong>
  <%= @question.id %>
  <%= @question.title %>
  <%= @question.content %>
</p>

<p><strong>Options</strong></p>
<ul>
  <% @question.options.each do |option| %>
    <li><%= option %></li>
  <% end %>
</ul>

<p>
  <strong>Correct Answer:</strong> <%= @question.correct_answer %>
</p>

<div>
  <%= link_to "Edit this question", edit_question_path(@question) %>
  <%= link_to "Back to questions", quiz_path(@question.quiz)  %> <br/><br/>
  <%= button_to "Destroy this question", @question, method: :delete %>
</div>